/*
	Custom frame for communicating
	with players during play
	Additions up to 21 Jun 06 by TA
*/

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class DataArea extends JLayeredPane implements ActionListener
{
	public JLayeredPane dataPane;
	public JLabel gameName, currentPlayer, whosTurn, currentColour, whichColour, whichColourTwo, whichColourThree, advicePlayOne, advicePlayTwo, advicePlayThree, menuOne, menuTwo, menuThree, choose;
	private JLabel diceFace;
	public JButton diceRoller, countButton1, countButton2, countButton3, countButton4;
	public int rollValue;
	public int counterChosen = 0;
	public boolean hasRolled = false;
	public boolean canGo = false;
	public boolean hasChosen = false;
   
	
	public Dice gameDice = new Dice();
	
	public DataArea()
	{
		//set up data pane area
		dataPane = new JLayeredPane();
		dataPane.setPreferredSize(new Dimension(200, 600));	
		
		gameName = new JLabel("Electronic Ludo v2.1");
		gameName.setBounds(0, 10, 250, 40);
		gameName.setFont(new Font("Verdena", Font.BOLD, 20));

		
		currentPlayer = new JLabel("Current Player:");
		currentPlayer.setBounds(0, 60, 100, 40);
		
		whosTurn = new JLabel("Default");
		whosTurn.setBounds(100, 60, 100, 40);
		
		currentColour = new JLabel("Colour:");
		currentColour.setBounds(44, 80, 100, 40);
		
		whichColour = new JLabel("Check player"); //updated 17 Jun 06
		whichColour.setBounds(100, 80, 100, 40);
		
		whichColourTwo = new JLabel("name"); //added 17 Jun 06
		whichColourTwo.setBounds(100, 95, 100, 40);
		
		advicePlayOne = new JLabel("To start: you need to roll a");
		advicePlayOne.setBounds(0, 240, 250, 40);
		advicePlayOne.setFont(new Font("Verdena", Font.BOLD, 14)); // new label (start hint) added 16 Jun 06 TA
		
		advicePlayTwo = new JLabel("6 to start each of your four");
		advicePlayTwo.setBounds(0, 260, 250, 40);
		advicePlayTwo.setFont(new Font("Verdena", Font.BOLD, 14)); // new label (start hint) added 16 Jun 06 TA
		
		advicePlayThree = new JLabel("pieces....");
		advicePlayThree.setBounds(0, 280, 250, 40);
		advicePlayThree.setFont(new Font("Verdena", Font.BOLD, 14)); // new label (start hint) added 16 Jun 06 TA
		
		menuOne = new JLabel("Once the game is started");
		menuOne.setBounds(0, 320, 250, 40);
		menuOne.setFont(new Font("Verdena", Font.BOLD, 14)); // new lowest label (additional menu) added 21 Jun 06 TA
		
		menuTwo = new JLabel("access the Menu bar for");
		menuTwo.setBounds(0, 340, 250, 40);
		menuTwo.setFont(new Font("Verdena", Font.BOLD, 14)); // new lowest label (additional menu) added 21 Jun 06 TA
		
		menuThree = new JLabel("latest 06 updates....");
		menuThree.setBounds(0, 360, 250, 40);
		menuThree.setFont(new Font("Verdena", Font.BOLD, 14)); // new lowest label (additional menu) added 21 Jun 06 TA
		
		dataPane.add(gameName, new Integer(1));
		dataPane.add(currentPlayer, new Integer(1));
		dataPane.add(whosTurn, new Integer(1));
		dataPane.add(currentColour, new Integer(1));
		dataPane.add(whichColour, new Integer(1));
		dataPane.add(whichColourTwo, new Integer(1));
		dataPane.add(advicePlayOne, new Integer(1)); //label added 16 Jun 06 TA
		dataPane.add(advicePlayTwo, new Integer(1)); //label added 16 Jun 06 TA
		dataPane.add(advicePlayThree, new Integer(1)); //label added 16 Jun 06 TA
		
		diceRoller = new JButton("Roll");
		diceRoller.setEnabled(false);
		diceRoller.addActionListener(this);
		diceRoller.setBounds(0, 140, 60, 35);
		
		dataPane.add(diceRoller, new Integer(1));
		
		//diceValue = new JLabel("Roll Value:");
		//diceValue.setBounds(0, 180, 100, 50);
		
		//dataPane.add(diceValue, new Integer(1));
		
		gameDice = new Dice();
		gameDice.diceHolder.setBounds(70, 140, 35, 35);
		dataPane.add(gameDice.diceHolder, new Integer(1));
		
		choose = new JLabel("Please choose a counter: ");
		choose.setBounds(0, 270, 200, 50);
		choose.setVisible(false);
		dataPane.add(choose, new Integer(1));
		
		countButton1 = new JButton("1");
		countButton1.setEnabled(false);
		countButton1.setBounds(0, 320, 48, 40);
		countButton1.addActionListener(this);
		dataPane.add(countButton1, new Integer(1));
		
		
		countButton2 = new JButton("2");
		countButton2.setEnabled(false);
		countButton2.setBounds(49, 320, 48, 40);
		countButton2.addActionListener(this);
		dataPane.add(countButton2, new Integer(1));
		
		
		countButton3 = new JButton("3");
		countButton3.setEnabled(false);
		//countButton3.setBounds(0, 310, 50, 40);
		countButton3.setBounds(98, 320, 48, 40);
		countButton3.addActionListener(this);
		dataPane.add(countButton3, new Integer(1));
		
		countButton4 = new JButton("4");
		countButton4.setEnabled(false);
		//countButton4.setBounds(60, 310, 50, 40);
		countButton4.setBounds(147, 320, 50, 40);
		countButton4.addActionListener(this);
		dataPane.add(countButton4, new Integer(1));
		
		
		//rollDisplay();
		
	}
	
	public void actionPerformed(ActionEvent e) 
	{
		if (e.getSource() == diceRoller)
		{
			
        	rollValue = gameDice.displayRolled();
        	hasRolled = true;
        	diceRoller.setEnabled(false);
        	
        	
        	
        }
        
        if (e.getSource() == countButton1)
        {
        	counterChosen = 1;
        	hasChosen = true;
        	allOff();	
        		
        }
        
        if (e.getSource() == countButton2)
        {
        	counterChosen = 2;
        	hasChosen = true;
        	allOff();
        	
        }
        
        if (e.getSource() == countButton3)
        {
        	counterChosen = 3;
        	hasChosen = true;
        	allOff();
        	
        }
        
        if (e.getSource() == countButton4)
        {
        	counterChosen = 4;
        	hasChosen = true;
        	allOff();
        	
        }
        
    	
	}
	
	public void delay()
	{
		for (int a = 0; a < 100; a++)
		{
			int b = 0;
		}
	}
	
	public int getRollValue()
	{
		return rollValue;
	}
	
	/*
	//rollValue = 1 + ((int) (Math.random() * 6));
        	
        //diceValue.setText("Dice = " + rollValue);
        //gameDice.rollDisplay();
        //rollValue = gameDice.getRoll();
        //gameDice.setFace(1);
        
        //rollDisplay();
        //gameDice.setFace(1);
				//gameDice.diceHolder.setIcon(gameDice.getFace());
				//delay();
				//gameDice.setFace(2);
				//gameDice.diceHolder.setIcon(gameDice.getFace());
				//delay();
				
		//gameDice.bleh(1);
		//delay();
		//gameDice.bleh(2);
		
		//test2();
		gameDice.newDisplay();
		//delay();
		//test1();
		
	*/
	
	public void allOff()
	{
		countButton1.setEnabled(false);
		countButton2.setEnabled(false);
		countButton3.setEnabled(false);
		countButton4.setEnabled(false);
	}
	
}
		
		
		