//Test dice animation


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class DiceAnimateTest extends JFrame {
	
   private static final int DELAY = 50;
   private static final int REPETITION = 50;
   
   private JLabel diceFace;
   Dice testDice = new Dice();

   public DiceAnimateTest()
   {
      super( "Animating Dice" );

      Container c = getContentPane();
      c.setLayout( new FlowLayout() );
      diceFace = new JLabel();

	  c.add(diceFace);      
	  setSize(150, 150);
      show();
	
	  for(int i = 0; i<=REPETITION; i++)
	  {
		testDice.roll();
		diceFace.setIcon(testDice.getFace());
		try{Thread.sleep(DELAY);}
        catch(Exception e){};
	  }
   }	
	

   public static void main( String args[] )
   { 
      DiceAnimateTest app = new DiceAnimateTest();

      app.addWindowListener(
         new WindowAdapter() {
            public void windowClosing( WindowEvent e )
            {
               System.exit( 0 );
            }
         }
      );
   }
}