/*
Menu bar - to enable access to 2006 updates,
credits and exit options

Tim Atherden - Jun, 2006
*/

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Menu extends JMenuBar
{
	public Menu()
	{
		
		JMenuBar bar = new JMenuBar();  // create menubar
		
		//Create File menu 
      	JMenu fileMenu = new JMenu( "File" );
      	fileMenu.setMnemonic( 'F' );
      	
      	//About item
      	JMenuItem aboutItem = new JMenuItem( "About" );
      	aboutItem.setMnemonic( 'A' );
      	aboutItem.addActionListener
      	(
        	new ActionListener() 
        	{
            	public void actionPerformed( ActionEvent e )
            	{
               		JOptionPane.showMessageDialog( Test.this,
                  	"Electronic Ludo Program v2.1" +
                  	"\n\nCreated for Co317 by" +
                  	"\n\nupdated Tim Atherden," +
                  	"\nexcluding Mark Butcher," +
                  	"\nexcluding Robert Panou" +
                  	"\nand" +
                  	"\nexcluding Luke Roberts" +
                  	"\n\n2006 Upgrades" +
                  	"\n\n1: Improved board graphic" +
                  	"\n2: Made sure players know 6 is necessary to start each piece" +
                  	"\n3: Updated this file menu so it starts from game outset" +
                  	"\n4: Installed computer player" +
                  	"\n5: Installed computer counters" +
                  	"\n\nUpgrade Copyright - Jun 2007",
                  	"About", JOptionPane.PLAIN_MESSAGE );
            	}
         	}
      	);
      	   	
      	fileMenu.add( aboutItem );
      	
      	//Updates item added 22 Jun 06 by TA
      	JMenuItem updateItem = new JMenuItem( "Update" );
      	updateItem.setMnemonic( 'U' );//Updated Mnemonic 23 Jun 06 by TA
      	updateItem.addActionListener
      	(
        	new ActionListener() 
        	{
            	public void actionPerformed( ActionEvent e )
            	{
               		JOptionPane.showMessageDialog( Test.this,
                  	"Electronic Ludo Program v2.1" +
                  	"\n\n2006 Upgrades" +
                  	"\n\n1: Improved board graphic" +
                  	"\n2: Made sure players know 6 is necessary to start each piece" +
                  	"\n3: Updated this file menu so it starts from game outset" +
                  	"\n4: Installed computer player" +
                  	"\n5: Installed computer counters" +
                  	"\n\nUpgrade Copyright - Jun 2006",
                  	"Update", JOptionPane.PLAIN_MESSAGE );
            	}
         	}
      	);      	   	
      	
      	fileMenu.add( updateItem );
      	     	   	

      	JMenuItem exitItem = new JMenuItem( "Exit" );
      	exitItem.setMnemonic( 'x' );
      	exitItem.addActionListener
      	(
      		new ActionListener() 
         	{
            	public void actionPerformed( ActionEvent e )
            	{
               		System.exit( 0 );
            	}
         	}
      	);
      	fileMenu.add( exitItem );
      	this.add( fileMenu );    // add File menu
   		//menubar ends   
   		
   	}//public menu
}//menu