/*
Start 
updated 28 Jun 06
Attempted Menu file extension on Updates
*/

//Updated 28 Jun 06 - updating computer player

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


public class Start extends JFrame
{
	private JPanel left, right;
	private JLayeredPane westSide, eastSide;
	private JTextArea one, two, three;
	private JLabel boardPic;
	public static Player[] playerList;
	static JLabel[] outerTrack = new JLabel[52];
	static JLabel[] redCounters = new JLabel[4];
	static JLabel[] greenCounters = new JLabel[4];
	static JLabel[] yellowCounters = new JLabel[4];
	static JLabel[] pcGreenCounters = new JLabel[4];
	static JLabel[] blueCounters = new JLabel[4];
	static JLabel[] pc
	 = new JLabel[5];
	static JLabel[] currentCounters = new JLabel[4];//store corner counters in array
	static JLabel[] checkCounters = new JLabel[4];//store counters in array 17/6/06
	static JLabel[] currentColour = new JLabel[4];//store colour counters in array 17/6/06
	static Counter[] playerCounters = new Counter[4];//store current players counters
	
	static JLabel[] redTrack = new JLabel[58];
	static JLabel[] greenTrack = new JLabel[58];
	static JLabel[] blueTrack = new JLabel[58];
	static JLabel[] yellowTrack = new JLabel[58];
	static JLabel[] pcGreenTrack = new JLabel[58];
	static JLabel[] currentTrack = new JLabel[58];//store current track array

	
	
	static DataArea playData;
	
	public Start()
	{
		
		super( "Electronic Ludo v2.1" );
		
		//Player[] playerList;//to store players
      
      	JMenuBar bar = new JMenuBar();  // create menubar
      	setJMenuBar( bar );  // set the menubar for the JFrame

      	//Create File menu 
      	JMenu fileMenu = new JMenu( "File" );
      	fileMenu.setMnemonic( 'F' );
      	
      	//About item
      	JMenuItem aboutItem = new JMenuItem( "About" );
      	aboutItem.setMnemonic( 'A' );
      	aboutItem.addActionListener
      	(
        	new ActionListener() 
        	{
            	public void actionPerformed( ActionEvent e )
            	{
               		JOptionPane.showMessageDialog( Start.this,
                  	"Electronic Ludo Program v2.1" +
                  	"\n\nCreated for Co317 by" +
                  	"\n\nupdated Tim Atherden," +
                  	"\nexcluding Mark Butcher," +
                  	"\nexcluding Robert Panou" +
                  	"\nand" +
                  	"\nexcluding Luke Roberts" +
                  	"\n\n2006 Upgrades" +
                  	"\n\n1: Improved board graphic" +
                  	"\n2: Made sure players know 6 is necessary to start each piece" +
                  	"\n3: Updated this file menu so it starts from game outset" +
                  	"\n4: Installed computer player" +
                  	"\n5: Installed computer counters" +
                  	"\n\nUpgrade Copyright - Jun 2006",
                  	"About", JOptionPane.PLAIN_MESSAGE );
            	}
         	}
      	);
      	
      	fileMenu.add( aboutItem );
      	
      	//Updates item added 22 Jun 06 by TA
      	JMenuItem updateItem = new JMenuItem( "Update" );
      	updateItem.setMnemonic( 'U' );//Updated Mnemonic 23 Jun 06 by TA
      	updateItem.addActionListener
      	(
        	new ActionListener() 
        	{
            	public void actionPerformed( ActionEvent e )
            	{
               		JOptionPane.showMessageDialog( Start.this,
                  	"Electronic Ludo Program v2.1" +
                  	"\n\n2006 Upgrades" +
                  	"\n\n1: Improved board graphic" +
                  	"\n2: Made sure players know 6 is necessary to start each piece" +
                  	"\n3: Updated this file menu so it starts from game outset" +
                  	"\n4: Installed computer player" +
                  	"\n5: Installed computer counters" +
                  	"\n\nUpgrade Copyright - Jun 2006",
                  	"Update", JOptionPane.PLAIN_MESSAGE );
            	}
         	}
      	);      	   	
      	
      	fileMenu.add( updateItem ); //add Updates menu

      	JMenuItem exitItem = new JMenuItem( "Exit" );
      	exitItem.setMnemonic( 'x' );
      	exitItem.addActionListener
      	(
      		new ActionListener() 
         	{
            	public void actionPerformed( ActionEvent e )
            	{
               		System.exit( 0 );
            	}
            	
         	}
      	);
      	fileMenu.add( exitItem );
      	bar.add( fileMenu );    // add File menu
   		//menubar ends   	
		
		//picturePanel
		left = new JPanel();
		
		ImageIcon ludo = new ImageIcon("board.gif");
      	
      	boardPic = new JLabel(ludo);
      	boardPic.setBounds(0, 0,
                    ludo.IconWidth(),
                    ludo.getIconHeight());
                    
                
		
		//dataPanel
		right = new JPanel();
		
		
		
		String s = "Here is where all of\n" +
                 "the information will\n" +
                 "be displayed to the players";
                 
        one = new JTextArea(s);
        //one.setBounds(10, 10, 200, 200);
        one.setBounds(0, 120, 100, 100);
        two = new JTextArea(s);
        two.setBounds(0, 0, 100, 100);
        
        westSide = new JLayeredPane();
        westSide.setPreferredSize(new Dimension(525, 600));
        eastSide = new JLayeredPane();
        eastSide.setPreferredSize(new Dimension(250, 600));
        
        //westSide.add(one, new Integer(1));
        westSide.add(boardPic, new Integer(1));
        
        playData = new DataArea();
        
        //eastSide.add(two, new Integer(2));
        //eastSide.add(one, new Integer(2));//shouldnt matter where
        								//placed in code!!!!
        
        left.add(westSide);
        right.add(playData.dataPane);
      	
      	
      	//Set up track
      	int keepTrack = 0;//counter for outTrack
      	int locationX = 0;//counter for x location
      	int locationY = 210;//counter for y location
      	
      	//1 - 6
      	for (int i = 0; i < 6; i++)
      	{
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationX = locationX + 35;
      		keepTrack++;
      	} 
      	
      	//7 - 12
      	locationY = 175;
      	for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationY = locationY - 35;
      		keepTrack++;
      	}	
      		
      	locationX = 245;
      	locationY = 0;//0
      	
        //individual top - 13
        JLabel top = new JLabel();
        top.setBounds(locationX, locationY, 35, 35);
        outerTrack[keepTrack] = top;//add to array
        westSide.add(top, new Integer(2));
        locationX = locationX + 35;
        keepTrack++;
        
        //14 - 19
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationY = locationY + 35;
      		keepTrack++;
      	}	
        
        locationX = locationX + 35;
        //20 - 25
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationX = locationX + 35;
      		keepTrack++;
      	}	
        
        locationX = 490;//490
      	locationY = 245;
      	
        //individual rightSide - 26
        JLabel rightSide = new JLabel();
        rightSide.setBounds(locationX, locationY, 35, 35);
        outerTrack[keepTrack] = rightSide;//add to array
        westSide.add(rightSide, new Integer(2));
        locationY = locationY + 35;
        keepTrack++;
        
        //27 - 32
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationX = locationX - 35;
      		keepTrack++;
      	}	
        
        locationY = locationY + 35;
        
        //33 - 38
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationY = locationY + 35;
      		keepTrack++;
      	}	
        
        locationX = locationX - 35;
        locationY = locationY - 35;
        
        //individual bottom - 39
        JLabel bottom = new JLabel();
        bottom.setBounds(locationX, locationY, 35, 35);
        outerTrack[keepTrack] = bottom;//add to array
        westSide.add(bottom, new Integer(2));
        locationX = locationX - 35;
        keepTrack++;
        
        
        //40 - 45
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationY = locationY - 35;
      		keepTrack++;
      	}	
        
        locationX = locationX - 35;
        
        //46 - 51
        for (int i = 0; i < 6; i++)
      	{
      		
      		JLabel track = new JLabel();
      		track.setBounds(locationX, locationY, 35, 35);
      		outerTrack[keepTrack] = track;//adds to array
      		westSide.add(track, new Integer(2));//adds to panel
      		
      		locationX = locationX - 35;
      		keepTrack++;
      	}	
        
        locationX = locationX + 35;
        locationY = locationY - 35;
        
        //individual leftSide - 52
        JLabel leftSide = new JLabel();
        leftSide.setBounds(locationX, locationY, 35, 35);
        outerTrack[keepTrack] = leftSide;//add to array
        westSide.add(leftSide, new Integer(2));
        //locationY = locationY - 35;
        //keepTrack++;
        //<--------------TRACK COMPLETE!!!!!
        
        
        //Set up individual tracks
        //RedTrack
        for (int i = 0; i < 52; i++)
        {
        	redTrack[i] = outerTrack[i];
        }
        
        //inside run to home for Red track
        //up to 58
        locationX = 35;
        locationY = 245;
        keepTrack = 52;
        
        for(int i = 0; i < 6; i++)
        {
        	JLabel track = new JLabel();
        	track.setBounds(locationX, locationY, 35, 35);
        	redTrack[keepTrack] = track;
        	westSide.add(track, new Integer(2));
        	
        	locationX = locationX + 35;
        	keepTrack++;
        }
        
        //GreenTrack
        int greenTracker = 13;
        for (int i = 0; i < 52; i++)
        {
        	greenTrack[i] = outerTrack[greenTracker];
        	greenTracker++;
        	
        	if (greenTracker == 52)//so that starts adding normal track
        	{
        		greenTracker = 0;
        	}
        
    	}        
        
        
        //inside run home for Green track
        locationX = 245;
        locationY = 35;
        keepTrack = 52;
        
        for(int i = 0; i < 6; i++)
        {
        	JLabel track = new JLabel();
        	track.setBounds(locationX, locationY, 35, 35);
        	greenTrack[keepTrack] = track;
        	westSide.add(track, new Integer(2));
        	
        	locationY = locationY + 35;
        	keepTrack++;
        }
        
                
        
        //BlueTrack
        int blueTracker = 26;
        for (int i = 0; i < 52; i++)
        {
        	blueTrack[i] = outerTrack[blueTracker];
        	blueTracker++;
        	
        	if (blueTracker == 52)//so that starts adding normal track
        	{
        		blueTracker = 0;
        	}
        
    	}  
    	
    	
    	//inside run home for Blue track
        locationX = 455;
        locationY = 245;
        keepTrack = 52;
        
        for(int i = 0; i < 6; i++)
        {
        	JLabel track = new JLabel();
        	track.setBounds(locationX, locationY, 35, 35);
        	blueTrack[keepTrack] = track;
        	westSide.add(track, new Integer(2));
        	
        	locationX = locationX - 35;
        	keepTrack++;
        }
    	
    	   	
    	//YellowTrack
        int yellowTracker = 39;
        for (int i = 0; i < 52; i++)
        {
        	yellowTrack[i] = outerTrack[yellowTracker];
        	yellowTracker++;
        	
        	if (yellowTracker == 52)//so that starts adding normal track
        	{
        		yellowTracker = 0;
        	}
        
    	}        
        
        
        //inside run home for Yellow track
        locationX = 245;
        locationY = 455;
        keepTrack = 52;
        
        for(int i = 0; i < 6; i++)
        {
        	JLabel track = new JLabel();
        	track.setBounds(locationX, locationY, 35, 35);
        	yellowTrack[keepTrack] = track;
        	westSide.add(track, new Integer(2));
        	
        	locationY = locationY - 35;
        	keepTrack++;
        }	
        
        //ComputerGreenTrack
        int pcGreenTracker = 39;
        for (int i = 0; i < 52; i++)
        {
        	pcGreenTrack[i] = outerTrack[yellowTracker];
        	pcGreenTracker++;
        	
        	if (pcGreenTracker == 52)//so that starts adding normal track
        	{
        		pcGreenTracker = 0;
        	}
        
    	}        
        
        
        //inside run home for computer Green track
        locationX = 245;
        locationY = 455;
        keepTrack = 52;
        
        for(int i = 0; i < 6; i++)
        {
        	JLabel track = new JLabel();
        	track.setBounds(locationX, locationY, 35, 35);
        	pcGreenTrack[keepTrack] = track;
        	westSide.add(track, new Integer(2));
        	
        	locationY = locationY - 35;
        	keepTrack++;
        }	
        
        //
        // counter start locations
        
        //red 
        
        /*
        In this section, tried defining just one label object
        'corner' and just over write the bounds each time
        however the program didnt like this and would only add
        whatever corner was defined last. So had to use
        individual corner names.
        */
        JLabel corner1 = new JLabel();
        corner1.setBounds(35, 35, 35, 35);
        redCounters[0] = corner1;
        westSide.add(corner1, new Integer(2));
        
        JLabel corner2 = new JLabel();
        corner2.setBounds(140, 35, 35, 35);
        redCounters[1] = corner2;
        westSide.add(corner2, new Integer(2));
        
        JLabel corner3 = new JLabel();
        corner3.setBounds(140, 140, 35, 35);
        redCounters[2] = corner3;
        westSide.add(corner3, new Integer(2));
        
        JLabel corner4 = new JLabel();	
        corner4.setBounds(35, 140, 35, 35);
        redCounters[3] = corner4;
        westSide.add(corner4, new Integer(2));
        
        
        //green Counters
        JLabel corner5 = new JLabel();
        corner5.setBounds(350, 35, 35, 35);
        greenCounters[0] = corner5;
        westSide.add(corner5, new Integer(2));
        
        JLabel corner6 = new JLabel();
        corner6.setBounds(455, 35, 35, 35);
        greenCounters[1] = corner6;
        westSide.add(corner6, new Integer(2));
        
        JLabel corner7 = new JLabel();
        corner7.setBounds(455, 140, 35, 35);
        greenCounters[2] = corner7;
        westSide.add(corner7, new Integer(2));
        
        JLabel corner8 = new JLabel();	
        corner8.setBounds(350, 140, 35, 35);
        greenCounters[3] = corner8;
        westSide.add(corner8, new Integer(2));
        
        
        //yellow Counters
        JLabel corner9 = new JLabel();
        corner9.setBounds(35, 350, 35, 35);
        yellowCounters[0] = corner9;
        westSide.add(corner9, new Integer(2));
        
        JLabel corner10 = new JLabel();
        corner10.setBounds(140, 350, 35, 35);
        yellowCounters[1] = corner10;
        westSide.add(corner10, new Integer(2));
        
        JLabel corner11 = new JLabel();
        corner11.setBounds(140, 455, 35, 35);
        yellowCounters[2] = corner11;
        westSide.add(corner11, new Integer(2));
        
        JLabel corner12 = new JLabel();	
        corner12.setBounds(35, 455, 35, 35);
        yellowCounters[3] = corner12;
        westSide.add(corner12, new Integer(2));
        
        //computer Yellow Counters
        JLabel corner17 = new JLabel();
        corner9.setBounds(35, 350, 35, 35);
        pcGreenCounters[0] = corner17;
        westSide.add(corner17, new Integer(2));
        
        JLabel corner18 = new JLabel();
        corner10.setBounds(140, 350, 35, 35);
        pcGreenCounters[1] = corner18;
        westSide.add(corner18, new Integer(2));
        
        JLabel corner19 = new JLabel();
        corner11.setBounds(140, 455, 35, 35);
        pcGreenCounters[2] = corner19;
        westSide.add(corner19, new Integer(2));
        
        JLabel corner20 = new JLabel();	
        corner12.setBounds(35, 455, 35, 35);
        pcGreenCounters[3] = corner20;
        westSide.add(corner20, new Integer(2));
        
        
        //blue Counters
        JLabel corner13 = new JLabel();
        corner13.setBounds(350, 350, 35, 35);
        blueCounters[0] = corner13;
        westSide.add(corner13, new Integer(2));
        
        JLabel corner14 = new JLabel();
        corner14.setBounds(455, 350, 35, 35);
        blueCounters[1] = corner14;
        westSide.add(corner14, new Integer(2));
        
        JLabel corner15 = new JLabel();
        corner15.setBounds(455, 455, 35, 35);
        blueCounters[2] = corner15;
        westSide.add(corner15, new Integer(2));
        
        JLabel corner16 = new JLabel();	
        corner16.setBounds(350, 455, 35, 35);
        blueCounters[3] = corner16;
        westSide.add(corner16, new Integer(2));
        
        
        //Adds both sides to the main content pane
        getContentPane().add(left, BorderLayout.WEST);
		getContentPane().add(right, BorderLayout.CENTER);
		
        //Sets size and displays it
        setSize(800, 700);
        show();
   }
   
   
   //Delay method to help when dice is 
   //rolled so that number
   //can be obtained without error
   public static void delay()
   {
		for (int i = 0; i < 100000000; i++)
   		{
   			int a = 1;
   		}
   }
   
   /*
   Method for checking to see if the move will involve
   landing on a counter of the opposite colour.
   If it does then that counter is sent back to 
   the start
   */
   public static void checkReturn()
   {
   		int counterChecker = 0;
   			  		
	  		//check for current colour
	  		switch(currentColour.getColour())
	  		{
	  			case 0:
	  			//is red so counter stays same
	  			break;
	  			
	  			case 1:
	  			//colour is green - start point 13 ahead
	  			counterChecker = 13;
	  			break;
	  			
	  			case 2:
	  			//colour is blue
	  			counterChecker = 26;
	  			break;
	  			
	  			case 3:
	  			//colour is yellow
	  			counterChecker = 39;
	  			break;
	  			
	  			case 4:
	  			//colour is pcGreen
	  			counterChecker = 52;
	  			break;
	  		}//endSwitch
	  		
	  		if (playerCounters[counterChosen].startSpace == true)
	  		{
	  			//playData. updated 15 Jun 06 for compilation reasons / TA
	  			int Value = 0;
	  		}
	  		
	  		int total = (playerCounters[counterChosen].position) + counterChecker + playData.rollValue;
	  		Counter returnArray[] = new Counter[4];//to store colour counter which will be moved back
	  		
	  		if (total > 51)
	  		{
	  			total = total - 52;
	  		}
	  		
	  		int saveTotal = total;//keeps track of original value
	  		
	  		//Check if space is occupied already
	  		if ( (outerTrack[total].getIcon()) != (testIcon.getIcon()) )
	  		{
	  			
	  			//Must then find out the colour of the counter
	  			//Cycle through each player to get each set of counters then
	  			//check each counter for its location and see if it matches
	  			
	  			for (int i = 0; i < humanPlayers; i++)
	  			{
	  				total = saveTotal;
	  				
	  				Player checkCounters = playerList[i];
	  				
	  				
	  				switch(checkCounters.getColour())
	  				{
	  					
	  					case 0://red
	  					if (checkCounters.getColour() != currentPlayer.getColour())
	  					{
	  					
		  					//scan through counters
		  					if ( (checkCounters.count1.getPosition()) == total) 
		  					{
		  						checkCounters.count1.setAtStart(true);
		  						checkCounters.count1.returnHome();
		  						redCounters[0].setIcon(checkCounters.count1.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count2.getPosition()) == total)
		  					{
		  						checkCounters.count2.setAtStart(true);
		  						checkCounters.count2.returnHome();
		  						redCounters[1].setIcon(checkCounters.count2.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count3.getPosition()) == total)
		  					{
		  						checkCounters.count3.setAtStart(true);
		  						checkCounters.count3.returnHome();
		  						redCounters[2].setIcon(checkCounters.count3.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count4.getPosition()) == total)
		  					{
		  						checkCounters.count4.setAtStart(true);
		  						checkCounters.count4.returnHome();
		  						redCounters[3].setIcon(checkCounters.count4.getPicture());
		  					}
	  					}//endcaseIf
	  					
	  					break;
	  					
	  					
	  					case 1://green
	  					if (checkCounters.getColour() != currentPlayer.getColour())
	  					{
		  					//scan through counters
		  					total = total - 13;//specific for green
		  					
		  					if (total < 0)
		  					{
		  						total = total + 52;
		  					} 
		  					
		  					if ( (checkCounters.count1.getPosition()) == total)
		  					{
		  						checkCounters.count1.setAtStart(true);
		  						checkCounters.count1.returnHome();
		  						greenCounters[0].setIcon(checkCounters.count1.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count2.getPosition()) == total)
		  					{
		  						checkCounters.count2.setAtStart(true);
		  						checkCounters.count2.returnHome();
		  						greenCounters[1].setIcon(checkCounters.count2.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count3.getPosition()) == total)
		  					{
		  						checkCounters.count3.setAtStart(true);
		  						checkCounters.count3.returnHome();
		  						greenCounters[2].setIcon(checkCounters.count3.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count4.getPosition()) == total)
		  					{
		  						checkCounters.count4.setAtStart(true);
		  						checkCounters.count4.returnHome();
		  						greenCounters[3].setIcon(checkCounters.count4.getPicture());
		  					}
	  					}//endCaseIf
	  					break;
	  					
	  					
	  					case 2://blue
	  					if (checkCounters.getColour() != currentPlayer.getColour())
	  					{
		  					//scan through counters
		  					
		  					total = total - 26;
		  					
		  					if (total < 0)
		  					{
		  						total = total + 52;
		  					}
		  					
		  					if ( (checkCounters.count1.getPosition()) == total)
		  					{
		  						checkCounters.count1.setAtStart(true);
		  						checkCounters.count1.returnHome();
		  						blueCounters[0].setIcon(checkCounters.count1.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count2.getPosition()) == total)
		  					{
		  						checkCounters.count2.setAtStart(true);
		  						checkCounters.count2.returnHome();
		  						blueCounters[1].setIcon(checkCounters.count2.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count3.getPosition()) == total)
		  					{
		  						checkCounters.count3.setAtStart(true);
		  						checkCounters.count3.returnHome();
		  						blueCounters[2].setIcon(checkCounters.count3.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count4.getPosition()) == total)
		  					{
		  						checkCounters.count4.setAtStart(true);
		  						checkCounters.count4.returnHome();
		  						blueCounters[3].setIcon(checkCounters.count4.getPicture());
		  					}
	  					}//endCaseIf
	  					break;
	  					
	  					
	  					case 3://yellow
	  					if (checkCounters.getColour() != currentPlayer.getColour())
	  					{
		  					//scan through counters
		  					
		  					total = total - 39;
		  					
		  					if (total < 0)
		  					{
		  						total = total + 52;
		  					}
		  					
		  					if ( (checkCounters.count1.getPosition()) == total)
		  					{
		  						checkCounters.count1.setAtStart(true);
		  						checkCounters.count1.returnHome();
		  						yellowCounters[0].setIcon(checkCounters.count1.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count2.getPosition()) == total)
		  					{
		  						checkCounters.count2.setAtStart(true);
		  						checkCounters.count2.returnHome();
		  						yellowCounters[1].setIcon(checkCounters.count2.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count3.getPosition()) == total)
		  					{
		  						checkCounters.count3.setAtStart(true);
		  						checkCounters.count3.returnHome();
		  						yellowCounters[2].setIcon(checkCounters.count3.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count4.getPosition()) == total)
		  					{
		  						checkCounters.count4.setAtStart(true);
		  						checkCounters.count4.returnHome();
		  						yellowCounters[3].setIcon(checkCounters.count4.getPicture());
		  					}
	  					}//endCaseIf
	  					break;
	  					
	  					case 4://pcGreen
	  					if (checkCounters.getColour() != currentPlayer.getColour())
	  					{
		  					//scan through counters
		  					
		  					total = total - 52;
		  					
		  					if (total < 0)
		  					{
		  						total = total + 65;
		  					}
		  					
		  					if ( (checkCounters.count1.getPosition()) == total)
		  					{
		  						checkCounters.count1.setAtStart(true);
		  						checkCounters.count1.returnHome();
		  						pcGreenCounters[0].setIcon(checkCounters.count1.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count2.getPosition()) == total)
		  					{
		  						checkCounters.count2.setAtStart(true);
		  						checkCounters.count2.returnHome();
		  						pcGreenCounters[1].setIcon(checkCounters.count2.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count3.getPosition()) == total)
		  					{
		  						checkCounters.count3.setAtStart(true);
		  						checkCounters.count3.returnHome();
		  						pcGreenCounters[2].setIcon(checkCounters.count3.getPicture());
		  					}
		  					
		  					if ( (checkCounters.count4.getPosition()) == total)
		  					{
		  						checkCounters.count4.setAtStart(true);
		  						checkCounters.count4.returnHome();
		  						pcGreenCounters[3].setIcon(checkCounters.count4.getPicture());
		  					}
	  					}//endCaseIf
	  					break;
	  					
	  				}//endSwitch
	  			}//endFor
	  			
	  				
	  			}//endIf
	}//checkReturn
   
   
   
   public static int counterChosen;//Store chosen counter
   public static JLabel testIcon = new JLabel();//For use with method above
   public static int humanPlayers;//Number of players
   public static int pcPlayers;//1 x computer player
   public static Player currentPlayer;//Current player
   
   public static void main( String args[] )
   {
      Test app = new Test();

      //Tim's code
	  //Information entered by players - Do you want to play the computer?
	    String pcStr = JOptionPane.showInputDialog("Do you want to play against the computer? Type '1' yes, or '2' no");
        pcPlayers = Integer.parseInt(pcStr);
        if (pcPlayers < 1)
        {
            pcStr = JOptionPane.showInputDialog("Please re-enter number of players (No more than 3 players)");
        }//if
        pcPlayers = Integer.parseInt(pcStr);

	  //Tim's code
	  //Information entered by players - names and number of players
	    String str = JOptionPane.showInputDialog("Enter the number of human players (No more than 4 players, only 3 if you are also playing the computer)");
        humanPlayers = Integer.parseInt(str);
        pcPlayers = Integer.parseInt(str);
        if (humanPlayers < 1 || humanPlayers > 4)
        {
            str = JOptionPane.showInputDialog("Please re-enter number of players (No more than 4 players)");
        }//if
        if (pcPlayers < 1)
        {
            str = JOptionPane.showInputDialog("Please re-enter number of players (No more than 3 players)");
        }//if
        humanPlayers = Integer.parseInt(str);
        		
		
		app.playerList = new Player[humanPlayers];
		app.playerList = new Player[pcPlayers];
		
	
		for (int i = 0; i < humanPlayers; i++)
		{
			
			Player dude = new Player(i, i);
			String newName = JOptionPane.showInputDialog("Player " + (i+1) + " please enter your name");
			dude.setName(newName);
			app.playerList[i] = dude;
			
        
		} 
	  
	  //put counters in start positions
	  for (int i = 0; i < humanPlayers; i++)
	  {
	  	Player dude = app.playerList[i];
	  	
	  	if (dude.getColour() == 0)
	  	{
	  		
	  		app.redCounters[0].setIcon(dude.count1.getPicture());	  		
	  		app.redCounters[1].setIcon(dude.count2.getPicture()); 		
	  		app.redCounters[2].setIcon(dude.count3.getPicture());  		
	  		app.redCounters[3].setIcon(dude.count4.getPicture());
	
	  		dude.setMyTurn(true);//sets player 1 to have first turn
	  		
	  	}
	  	
	  	if (dude.getColour() == 1)
	  	{
	  		app.greenCounters[0].setIcon(dude.count1.getPicture());
	  		app.greenCounters[1].setIcon(dude.count2.getPicture());
	  		app.greenCounters[2].setIcon(dude.count3.getPicture());
	  		app.greenCounters[3].setIcon(dude.count4.getPicture());
	  	}
	  	
	  	if (dude.getColour() == 2)
	  	{
	  		app.blueCounters[0].setIcon(dude.count1.getPicture());
	  		app.blueCounters[1].setIcon(dude.count2.getPicture());
	  		app.blueCounters[2].setIcon(dude.count3.getPicture());
	  		app.blueCounters[3].setIcon(dude.count4.getPicture());
	  	}
	  	
	  	if (dude.getColour() == 3)
	  	{
	  		app.yellowCounters[0].setIcon(dude.count1.getPicture());
	  		app.yellowCounters[1].setIcon(dude.count2.getPicture());
	  		app.yellowCounters[2].setIcon(dude.count3.getPicture());
	  		app.yellowCounters[3].setIcon(dude.count4.getPicture());
	  	}
	  	
	  	if (dude.getColour() == 4)
	  	{
	  		app.pcGreenCounters[0].setIcon(dude.count1.getPicture());
	  		app.pcGreenCounters[1].setIcon(dude.count2.getPicture());
	  		app.pcGreenCounters[2].setIcon(dude.count3.getPicture());
	  		app.pcGreenCounters[3].setIcon(dude.count4.getPicture());
	  	}	  	
	  	
	  	
	 }
	  
	  
	  app.playData.whosTurn.setText(playerList[0].getName());//display first player's name
	  app.playData.whosTurn.setText("Length " + app.outerTrack.length);
	  
	  //testing
	  ImageIcon red = new ImageIcon("redCounter.gif");
	  
	  /*
	  for (int i = 0; i < app.redTrack.length; i++)
      {
      		
      			app.redTrack[i].setIcon(red);
      			app.delay();
      			app.redTrack[i].setIcon(null);
      }*/
      
      
	  //Game Starts
	  
	  //Find whos turn it is next
	  
	  /*
	  for (int i = 0; i < humanPlayers; i++)
	  {
	  	Player dude = app.playerList[i];
	  	if(dude.getMyTurn() == true)
	  	{
	  		currentPlayer = dude;
	  	}
	  }//endFor*/
	  
	  //Adds current player's counters to array
	  //playerCounters[0] = currentPlayer.count1;
	  //playerCounters[1] = currentPlayer.count2;
	  //playerCounters[2] = currentPlayer.count3;
	  //playerCounters[3] = currentPlayer.count4;
	  
	  /*
	  switch(currentPlayer.getColour())
	  {
	  	
	  	case 0://sets current track and counters to red
	  	for (int i = 0; i < 4; i++)
	  	{
	  		currentCounters[i] = redCounters[i];
	  	}
	  	
	  	for (int i = 0; i < 52; i++)
	  	{
	  		currentTrack[i] = redTrack[i];		
	  	}
	  	
	  	
	  	break;
	  	
	  	
	  	case 1://sets current track and counters to green
	  	for (int i = 0; i < 4; i++)
	  	{
	  		currentCounters[i] = greenCounters[i];
	  	}
	  	
	  	for (int i = 0; i < 52; i++)
	  	{
	  		currentTrack[i] = greenTrack[i];		
	  	}
	  	
	  	break;
	  	
	  	
	  	case 2://sets current track and counters to blue
	  	for (int i = 0; i < 4; i++)
	  	{
	  		currentCounters[i] = blueCounters[i];
	  	}
	  	
	  	for (int i = 0; i < 52; i++)
	  	{
	  		currentTrack[i] = blueTrack[i];		
	  	}
	  	
	  	break;
	  	
	  	
	  	case 3://sets current track and counters to yellow
	  	for (int i = 0; i < 4; i++)
	  	{
	  		currentCounters[i] = yellowCounters[i];
	  	}
	  	
	  	for (int i = 0; i < 52; i++)
	  	{
	  		currentTrack[i] = yellowTrack[i];		
	  	}
	  	
	  	break;
	  }
	  */
	  //player rolls dice
	  
	  boolean gameOver = false;
	  
	  while (gameOver == false)
	  {
	  	//Game Starts
	  
	  	
	  
	  	//Find whos turn it is next
	  	for (int i = 0; i < humanPlayers; i++)
	  	{
	  		Player dude = app.playerList[i];
	  		if(dude.getMyTurn() == true)
	  		{
	  			currentPlayer = dude;
	  		}
	  	}//endFor
	  	
	  	
	  	//Append text to display current player's name 
	  	app.playData.whosTurn.setText(currentPlayer.getName());
	  	
	  	
	  	//Adds current player's counters to array
	    playerCounters[0] = currentPlayer.count1;
	    playerCounters[1] = currentPlayer.count2;
	    playerCounters[2] = currentPlayer.count3;
	    playerCounters[3] = currentPlayer.count4;
	    	  	
	  	
	  	//Test for end thingy
	  	
	  	//playerCounters[1].isAtHome = true;
	    //playerCounters[2].isAtHome = true;
	    //playerCounters[3].isAtHome = true;
	  	
	  	
	  	//should put switch in here!
	  	
	  	//Put current players track and counters into arrays
	  	switch(currentPlayer.getColour())
	  	{
	  	
	  		case 0://sets current track and counters to red
	  		for (int i = 0; i < 4; i++)
	  		{
	  			currentCounters[i] = redCounters[i];
	  		}
	  	
	  		for (int i = 0; i < 58; i++)
	  		{
	  			currentTrack[i] = redTrack[i];		
	  		}
	  	
	  	
	  		break;
	  	
	  	
	  		case 1://sets current track and counters to green
	  		for (int i = 0; i < 4; i++)
	  		{
	  			currentCounters[i] = greenCounters[i];
	  		}
	  		
	  		for (int i = 0; i < 58; i++)
	  		{
	  			currentTrack[i] = greenTrack[i];		
	  		}
	  		
	  		break;
	  	
	  	
	  		case 2://sets current track and counters to blue
	  		for (int i = 0; i < 4; i++)
	  		{
	  			currentCounters[i] = blueCounters[i];
	  		}
	  		
	  		for (int i = 0; i < 58; i++)
	  		{
	  			currentTrack[i] = blueTrack[i];		
	  		}
	  		
	  		break;
	  	
	  	
	  		case 3://sets current track and counters to yellow
	  		for (int i = 0; i < 4; i++)
	  		{
	  			currentCounters[i] = yellowCounters[i];
	  		}
	  		
	  		for (int i = 0; i < 58; i++)
	  		{
	  			currentTrack[i] = yellowTrack[i];		
	  		}
	  	
	  		break;
	  		
	  		case 4://sets current track and counters to yellow
	  		for (int i = 0; i < 4; i++)
	  		{
	  			currentCounters[i] = pcGreenCounters[i];
	  		}
	  		
	  		for (int i = 0; i < 58; i++)
	  		{
	  			currentTrack[i] = pcGreenTrack[i];		
	  		}
	  	
	  		break;
	  	}//end switch
	  		
	  	
	  	
	  	
	  	
	  	//System.out.println("output is " + currentTrack[20].getIcon());
	  	/*
	  	Here a while loop is used - this way the roll button will
	  	stay active until the player has rolled.
	  	The player is also unable to select any counters as a result
	  	until the dice has rolled
	  	*/
	  	while (app.playData.hasRolled == false)
	  	{
	  		app.playData.diceRoller.setEnabled(true);
	  		delay();//delay required otherwise button can be clicked twice
	  		//to test below:
	  		//app.playData.rollValue = 6;
	  		
	  	}//dice is rolled
	  	
	  	app.playData.hasRolled = false;//reset so can roll again
	  	//app.playData.rollValue = 6; //-- use to test for different roll values
	  	
	  	/*
	  	Player chooses counter to move.
	  	This if statement allows the relevant counter
	  	choice buttons to be available to the player
	  	*/
	  	if (app.playData.rollValue == 6)
	  	{
	  		/*
	  		Need to work out which counters can be moved.
	  		With a 6 any can be moved, so all buttons
	  		must be available
	  		*/
	  		app.playData.countButton1.setEnabled(true);
	  		app.playData.countButton2.setEnabled(true);
	  		app.playData.countButton3.setEnabled(true);
	  		app.playData.countButton4.setEnabled(true);
	  		
	  		/*
	  		The can go variable enables the computer to know 
	  		if the user can make a move or not, for example
	  		if no counters can be moved
	  		*/
	  		
	  		app.playData.canGo = true;
	  		
	  		//gameOver = true;
	  		
	  	}
	  	
	  	/*
	  	If a 6 is not rolled the player can only move counters
	  	that are currently in play, so each counter is checked
	  	and if they are able to move then the relevant button
	  	is activated
	  	*/
	  	
	  	else
	  	{
	  		//test to check below works:
	  		//currentPlayer.count1.startSpace = false;
	  		//currentPlayer.count3.startSpace = false;
	  		
	  		if (currentPlayer.count1.startSpace == true || currentPlayer.count1.isAtHome == true)
	  		{
	  			app.playData.countButton1.setEnabled(false);
	  		}
	  		
	  			else
	  			{	
	  				app.playData.countButton1.setEnabled(true);
	  				app.playData.canGo = true;
	  			}//end else if count1
	  		
	  		
	  		if (currentPlayer.count2.startSpace == true || currentPlayer.count2.isAtHome == true)
	  		{
	  			app.playData.countButton2.setEnabled(false);
	  		}
	  		
	  			else
	  			{	
	  				app.playData.countButton2.setEnabled(true);
	  				app.playData.canGo = true;
	  			}//end else if count2
	  		
	  		
	  		if (currentPlayer.count3.startSpace == true || currentPlayer.count3.isAtHome == true)
	  		{
	  			app.playData.countButton3.setEnabled(false);
	  		}
	  		
	  			else
	  			{	
	  				app.playData.countButton3.setEnabled(true);
	  				app.playData.canGo = true;
	  			}//end else if count3
	  		
	  		
	  		if (currentPlayer.count4.startSpace == true || currentPlayer.count4.isAtHome == true)
	  		{
	  			app.playData.countButton4.setEnabled(false);
	  		}
	  		
	  			else
	  			{	
	  				app.playData.countButton4.setEnabled(true);
	  				app.playData.canGo = true;
	  			}//end else if count4
	  		
	  			
	  	//gameOver = true;
	  	
	  }//else players counter is chosen
	  
	  //now we must move the counter
	  //stage 1 - make counter vanish from current spot
	  //originally switch was here
	  
	  
	  //Pause so that button can be clicked and counter 
	  //can be chosen
	  if (app.playData.canGo == true)
	  {
	  	/*
	  	This while loop is just to keep the player at the point
	  	of being able to select a button.
	  	Without this conditional while loop the code would obviously
	  	keep on executing and an error will occur further down as
	  	a counter will not have been chosen.
	  	*/
	  	while (app.playData.hasChosen == false)
	  	{
	  			//int a = 0;
	  	}
	  }
	  	
	  //This resets the variable for the next player
	  app.playData.hasChosen = false;
	  
	  //minus 1 to allow for array number, counter 1 = position 0
	  counterChosen = (app.playData.counterChosen) - 1;
	  
	  int bleh = app.playData.rollValue;
	  JOptionPane.showMessageDialog( 
	  			null,
                	"It got here with a " + bleh,
                  	"Test", JOptionPane.PLAIN_MESSAGE );
	  
	  //in array and so on
	  
	  
	  //test for else statement
	  //currentPlayer.count1.startSpace = false;
	  
	  
	  if (app.playData.canGo == true)
	  {
	  	
	  	int tester = playerCounters[counterChosen].position + app.playData.rollValue;
	  
	  
	  //System.out.println("Current position = " + playerCounters[counterChosen].position);
	  //System.out.println("Roll value is = " + app.playData.rollValue);
	  //System.out.println("Value is = " + tester);
	  
	  //System.out.println("Current: " + currentTrack[playerCounters[counterChosen].getPosition()]);
	  //System.out.println("Outside: " + outerTrack[playerCounters[counterChosen].getPosition()]);
	  //switch (counterChosen)
	  //{
	  	//case 0://counter 1 ---- WORKS :D
	  
	  //First work out if counter can make it home
	  
	  	/*if ((playerCounters[counterChosen].position + app.playData.rollValue) >= 58)
	  	{
	  		//disappear from spot
	  		currentTrack[playerCounters[counterChosen].getPosition()].setIcon(null);
	  		//set new position to end
	  		playerCounters[counterChosen].setPosition(57);//home (end) space
	  		//reappear at home space
	  		currentTrack[playerCounters[counterChosen].getPosition()].setIcon(playerCounters[counterChosen].getPicture());
			//set isAtHome to true
			playerCounters[counterChosen].isAtHome = true;
		}*/
	  	
	  	if (app.playData.rollValue == 6)
	  	{
	  		//if (currentPlayer.count1.startSpace == true)
	  		if (playerCounters[counterChosen].startSpace == true)
	  		{
	  			checkReturn();
	  			
	  			currentCounters[counterChosen].setIcon(null);//clear the space
	  			//currentPlayer.count1.startSpace = false;//not at start now
	  			playerCounters[counterChosen].startSpace = false;
	  			//sets track position to display counter (start of track)
	  			//currentTrack[0].setIcon(currentPlayer.count1.getPicture());
	  			currentTrack[0].setIcon(playerCounters[counterChosen].getPicture());
	  			//break;
	  			
	  			//first find what colour the current player is
	  			
	  			//check if other colours are on that space
	  			//JLabel testIcon = new JLabel();
	  	
	  			if( (currentTrack[20].getIcon()) == (testIcon.getIcon()) )
	  			{
	  				System.out.println("Yup code works fine");
	  			
	  			}//e
	  	
	  	
	  	//get counter colour
	  	//compare it to current counter colour
	  	//if different then reference correct colour track
	  	//reference correct counter colour
	  	//return it to the start and reset numbers!!!
	  	
	  	/*
	  		int counterChecker = 0;
	  		
	  		//check for current colour
	  		switch(currentPlayer.getColour())
	  		{
	  			case 0:
	  			//is red so counter stays same
	  			break;
	  			
	  			case 1:
	  			//colour is green - start point 13 ahead
	  			counterChecker = 13;
	  			break;
	  			
	  			case 2:
	  			//colour is blue
	  			counterChecker = 26;
	  			break;
	  			
	  			case 3:
	  			//colour is yellow
	  			counterChecker = 39;
	  			break;
	  		}//endSwitch
	  		
	  		int total = (playerCounters[counterChosen].position) + counterChecker + app.playData.rollValue;
	  		Counter returnArray[] = new Counter[4];//to store colour counter which will be moved back
	  		
	  		if (total > 51)
	  		{
	  			total = total - 52;
	  		}
	  		
	  		int saveTotal = total;//keeps track of original value
	  		
	  		//Check if space is occupied already
	  		if ( (outerTrack[total].getIcon()) != (testIcon.getIcon()) )
	  		{
	  			
	  			//Must then find out the colour of the counter
	  			//Cycle through each player to get each set of counters then
	  			//check each counter for its location and see if it matches
	  			
	  			for (int i = 0; i < humanPlayers; i++)
	  			{
	  				total = saveTotal;
	  				
	  				Player checkCounters = app.playerList[i];
	  				
	  				//int checkColour = checkCounters.getColour();
	  				
	  				switch(checkCounters.getColour())
	  				{
	  					
	  					case 0://red
	  					//scan through counters
	  					if ( (checkCounters.count1.getPosition()) == total)
	  					{
	  						checkCounters.count1.setAtStart(true);
	  						checkCounters.count1.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count2.getPosition()) == total)
	  					{
	  						checkCounters.count2.setAtStart(true);
	  						checkCounters.count2.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count3.getPosition()) == total)
	  					{
	  						checkCounters.count3.setAtStart(true);
	  						checkCounters.count3.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count4.getPosition()) == total)
	  					{
	  						checkCounters.count4.setAtStart(true);
	  						checkCounters.count4.returnHome();
	  					}
	  					
	  					break;
	  					
	  					
	  					case 1://green
	  					//scan through counters
	  					total = total - 13;//specific for green
	  					
	  					if (total < 0)
	  					{
	  						total = total + 52;
	  					} 
	  					
	  					if ( (checkCounters.count1.getPosition()) == total)
	  					{
	  						checkCounters.count1.setAtStart(true);
	  						checkCounters.count1.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count2.getPosition()) == total)
	  					{
	  						checkCounters.count2.setAtStart(true);
	  						checkCounters.count2.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count3.getPosition()) == total)
	  					{
	  						checkCounters.count3.setAtStart(true);
	  						checkCounters.count3.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count4.getPosition()) == total)
	  					{
	  						checkCounters.count4.setAtStart(true);
	  						checkCounters.count4.returnHome();
	  					}
	  					
	  					break;
	  					
	  					
	  					case 2://blue
	  					//scan through counters
	  					
	  					total = total - 26;
	  					
	  					if (total < 0)
	  					{
	  						total = total + 26;
	  					}
	  					
	  					if ( (checkCounters.count1.getPosition()) == total)
	  					{
	  						checkCounters.count1.setAtStart(true);
	  						checkCounters.count1.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count2.getPosition()) == total)
	  					{
	  						checkCounters.count2.setAtStart(true);
	  						checkCounters.count2.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count3.getPosition()) == total)
	  					{
	  						checkCounters.count3.setAtStart(true);
	  						checkCounters.count3.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count4.getPosition()) == total)
	  					{
	  						checkCounters.count4.setAtStart(true);
	  						checkCounters.count4.returnHome();
	  					}
	  					
	  					break;
	  					
	  					
	  					case 3://yellow
	  					//scan through counters
	  					
	  					total = total - 39;
	  					
	  					if (total < 0)
	  					{
	  						total = total + 52;
	  					}
	  					
	  					if ( (checkCounters.count1.getPosition()) == total)
	  					{
	  						checkCounters.count1.setAtStart(true);
	  						checkCounters.count1.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count2.getPosition()) == total)
	  					{
	  						checkCounters.count2.setAtStart(true);
	  						checkCounters.count2.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count3.getPosition()) == total)
	  					{
	  						checkCounters.count3.setAtStart(true);
	  						checkCounters.count3.returnHome();
	  					}
	  					
	  					if ( (checkCounters.count4.getPosition()) == total)
	  					{
	  						checkCounters.count4.setAtStart(true);
	  						checkCounters.count4.returnHome();
	  					}
	  					
	  					break;
	  					
	  				}//endSwitch
	  				
	  			}//endIf
	  			
	  			*/ 			
	  			
	  			/*
	  			//If it is then check if it is a different coloured counter
	  			if ( (outerTrack[total].getColour()) != (currentPlayer.getColour()) )
	  			{
	  				
	  				//If it is then send that counter back to the start
	  				//First get correct counters into array
	  				switch(outerTrack[total].getColour())
	  				{
	  					case 0://red
	  					
	  					for (int i = 0; i < 4; i++)
	  					{
	  						returnArray[i] = redCounters[i];
	  					}
	  	
	  					break;
	  	
	  	
	  					case 1://sets current track and counters to green
	  					for (int i = 0; i < 4; i++)
	  					{
	  						returnArray[i] = greenCounters[i];
	  					}
	  			
	  					break;
	  	
	  	
				  		case 2://sets current track and counters to blue
				  		for (int i = 0; i < 4; i++)
				  		{
				  			returnArray[i] = blueCounters[i];
				  		}
				  		
				  		break;
	  	
				  	
				  		case 3://sets current track and counters to yellow
				  		for (int i = 0; i < 4; i++)
				  		{
				  			returnArray[i] = yellowCounters[i];
				  		}
				  	
				  		break;
				  	}//end switch
	  					
	  				//set counter to be at start
	  				returnArray[outerTrack[total].getCounterNumber()].setAtStart(true);
	  				
	  				//set location to be 0
	  				returnArray[outerTrack[total]].returnHome();
	  				
	  				//No need to make space null because next counter will over-write it
	  			}//subIf */
	  		//}//if
	  			
	  			
	  		//if value greater then 51 then minus 52 from it
	  			
	  			
	  			//if(outerTrack[playerCounters[counterChosen].position].getIcon
	  			//redTrack
	  			//greenTrack
	  			//blueTrack
	  			//yellowTrack
	  			
	  		}
	  		
	  		//edited was >=58
	  		else if ((playerCounters[counterChosen].position + app.playData.rollValue) > 57)
	  		{
	  			//disappear from spot
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(null);
	  			//set new position to end
	  			playerCounters[counterChosen].setPosition(57);//home (end) space
	  			//reappear at home space
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(playerCounters[counterChosen].getPicture());
				//set isAtHome to true
				playerCounters[counterChosen].isAtHome = true;
			}
	  		
	  		else
	  		{
	  			checkReturn();
	  			//if (currentTrack[tester]
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(null);
	  			playerCounters[counterChosen].setPosition(app.playData.rollValue);	
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(playerCounters[counterChosen].getPicture());
	  			try{
	  			//Check to see if any other counters were on that spot and
	  			//if so replace the blank space with current value
	  			
	  			//for(int i = 0; i < 4; i++)
	  			//{
	  				//If counter is in a position but icon value is 'null' means
	  				//that counter that has just moved was on top of it, so it
	  				//replaces the icon with the correct counter's picture
	  			//	if(currentTrack[playerCounters[i].getPosition()].getIcon().equals("null"))
	  			//	{
	  			//		System.out.println("Made it to here :-D 1 ");
	  			//		currentTrack[playerCounters[i].getPosition()].setIcon(playerCounters[i].getPicture());
	  						
	  			//	}//endIf
	  			//}//endFor
	  			
	  			
	  			for(int i = 0; i < 4; i++)
	  			{
	  				if(playerCounters[i].isAtStart() == false)
	  				{
	  					currentTrack[playerCounters[i].getPosition()].setIcon(playerCounters[i].getPicture());
	  				}
	  			}
	  					
	  			
	  			
	  			}//try
	  			
	  			/*
	  			If not all 4 counters are on the track then a null pointer exception
	  			occurs because the array is not full - so this catches it and
	  			allows the game to continue
	  			*/
	  			catch(NullPointerException npe1)
	  			{
	  			
	  				System.out.println("Got to first exception");
	  			}	  		
	  			
	  		}
	  			
	  	}
	  	
	  	
	  	//if (currentPlayer.count1.startSpace == false)//means it is on track
	  	//if (playerCounters[counterChosen].startSpace == false)
	  	else
	  	{
	  		if ((playerCounters[counterChosen].position + app.playData.rollValue) > 57)
	  		{
	  			//disappear from spot
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(null);
	  			//set new position to end
	  			playerCounters[counterChosen].setEnd(57);//home (end) space
	  			//reappear at home space
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(playerCounters[counterChosen].getPicture());
				//set isAtHome to true
				playerCounters[counterChosen].isAtHome = true;
			}
	  		
			else
			{  		
	  			//int newPos = (currentPlayer.count1.getPosition()) + rollValue;
		  		checkReturn();
	  			//Makes counter disappear from current track position
	  			//currentTrack[currentPlayer.count1.getPosition()].setIcon(null);
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(null);
	  			//currentPlayer.count1.setPosition(app.playData.rollValue);//set new counter position
	  			playerCounters[counterChosen].setPosition(app.playData.rollValue);
	  			//Makes counter visible in new position on track
	  			//currentTrack[currentPlayer.count1.getPosition()].setIcon(currentPlayer.count1.getPicture());
	  			currentTrack[playerCounters[counterChosen].getPosition()].setIcon(playerCounters[counterChosen].getPicture());
	  			
	  			System.out.println("It got here");
	  			System.out.println("Value is " + playerCounters[counterChosen].position);
	  			
	  			try{
	  			//Check to see if any other counters were on that spot and
	  			//if so replace the blank space with current value
	  			
	  			
	  			//for(int i = 0; i < 4; i++)
	  			//{
	  				//If counter is in a position but icon value is 'null' means
	  				//that counter that has just moved was on top of it, so it
	  				//replaces the icon with the correct counter's picture
	  			//	if(currentTrack[playerCounters[i].getPosition()].getIcon().equals("null"))
	  			//	{
	  			//		System.out.println("Made it to here :-D 2");
	  			//		currentTrack[playerCounters[i].getPosition()].setIcon(playerCounters[i].getPicture());
	  						
	  			//	}//endIf
	  			//}//endFor
	  			
	  			
	  			for(int i = 0; i < 4; i++)
	  			{
	  				if(playerCounters[i].isAtStart() == false)
	  				{
	  					currentTrack[playerCounters[i].getPosition()].setIcon(playerCounters[i].getPicture());
	  				}
	  			}
	  			
	  			}//try
	  			
	  			catch(NullPointerException npe1)
	  			{
	  			
	  				System.out.println("Got to second exception");	
	  			}
	  			
	  		}
	  	
	  	}//if
	  		//break;
	  	}//canGo if	
	  	//else
	  	//{
	  		
	  		
	  	//}
	  			
	  	//break;
	 //}//switch
	 
	//End of game function
	/*
		Check to see if ALL the current player's counters
		have reached the end - if so that player is
		declared the winner and the game ends
	*/
	
	
	
	int checkEnd = 0;
	
	for(int i = 0; i < 4; i++)
	{
		if (playerCounters[i].isAtHome == true)
		{
			checkEnd++;
			
			if(checkEnd == 4)
			{
				gameOver = true;
			}//if
		}//if
	}//endFor
	
	checkEnd = 0;//reset for next check
	
	
	if(gameOver != true)
	{
		app.playData.canGo = false;	
		currentPlayer.setMyTurn(false);
	
		//Determine who is the next player
		int determine = currentPlayer.getPlayer();
	
		/*
		If current player number is last in player list then
		set current player to be player 1
		*/
		if (determine >= (app.playerList.length - 1))
		{
			currentPlayer = app.playerList[0];
			currentPlayer.setMyTurn(true);
		
		}//if
	
		/*
		Else set current player to be the next one in the list
		*/
		else
		{
			currentPlayer = app.playerList[(determine + 1)];
			currentPlayer.setMyTurn(true);
		}//else
		
		  //stage 2 - change location in array - done
		  //stage 3 - make counter reappear on correct spot- done
	}//endIf
	
	}//while
	  
	
	//End of game display
	
	System.out.println("Congratulations " + currentPlayer.playerName + " you win!!");
	
	  /*while (gameOver == false)
	  {
	  	if(app.playData.gameDice.getRoll() == 6)
	  	{
	  		//check for counter to be added to track
	  		if (currentPlayer.count1.isAtStart() == true)
	  		{
	  			currentPlayer.count1.setAtStart(false);
	  			currentPlayer.count1.setPosition(0);
	  			app.outerTrack[0].setIcon(currentPlayer.count1.getPicture());
	  			gameOver = true;
	  		}
	 	}
	}//while */
	  		
	  //Check to see if counter can make it home in next move
	  
	  
	  		
	  
	  
      app.addWindowListener(
         new WindowAdapter() {
            public void windowClosing( WindowEvent e )
            {
               System.exit( 0 );
            }
         }
      );
      
      
      //TRACK TEST
      //TRAVELS ENTIRE OF OUTER TRACK
      /*for (int i = 0; i < app.outerTrack.length; i++)
      {
      		
      			app.outerTrack[i].setIcon(red);
      			app.delay();
      			app.outerTrack[i].setIcon(null);
      }*/
      
      /*
      //TRACK TEST 
      //TRAVELS ENTIRE OF GREEN TRACK
      for (int i = 0; i < app.greenTrack.length; i++)
      {
      		
      			app.greenTrack[i].setIcon(red);
      			app.delay();
      			app.greenTrack[i].setIcon(null);
      }
      
      //TRACK TEST 
      //TRAVELS ENTIRE OF BLUE TRACK
      for (int i = 0; i < app.blueTrack.length; i++)
      {
      		
      			app.blueTrack[i].setIcon(red);
      			app.delay();
      			app.blueTrack[i].setIcon(null);
      }
      
      //TRACK TEST 
      //TRAVELS ENTIRE OF YELLOW TRACK
      for (int i = 0; i < app.yellowTrack.length; i++)
      {
      		
      			app.yellowTrack[i].setIcon(red);
      			app.delay();
      			app.yellowTrack[i].setIcon(null);
      }*/
      
      app.pack();
   }

   
}
        
		
		