/*
  Dice.java
  Randomly generates a value between 1 and 6
  Ludo Masters,  February 2005
*/
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dice extends JLabel
{
	public int rollValue;
	public ImageIcon diceFace;
	public JLabel diceHolder = new JLabel(diceFace);
	
    public int roll()
    {
        
        //generates random number between 1 & 6
        rollValue = 1 + (int) (Math.random() * 6);
        //rollValue = 6;
        return rollValue;
  
    }//roll
    
    public int getRoll()
    {
    	return rollValue;
	}//getRoll
    
    public void setFace(int face)
    {
    	if (face == 1)
    	{
    		diceFace = new ImageIcon("face1.gif");
    		diceHolder.setIcon(this.getFace());
    	}
    	
    	if (face == 2)
    	{
    		diceFace = new ImageIcon("face2.gif");
    		diceHolder.setIcon(this.getFace());
    	}
    	
    	if (face == 3)
    	{
    		diceFace = new ImageIcon("face3.gif");
    		diceHolder.setIcon(this.getFace());
    	}
    	
    	if (face == 4)
    	{
    		diceFace = new ImageIcon("face4.gif");
    		diceHolder.setIcon(this.getFace());
    	}
    	
    	if (face == 5)
    	{
    		diceFace = new ImageIcon("face5.gif");
    		diceHolder.setIcon(this.getFace());
    	}
    	
    	if (face == 6)
    	{
    		diceFace = new ImageIcon("face6.gif");
    		diceHolder.setIcon(this.getFace());
    	}
	}
	
	public ImageIcon getFace()
	{
		return diceFace;
	}
	
	public int displayRolled()
	{
		rollValue = this.roll();
		this.setFace(rollValue);
		return rollValue;
	}
			
    

}//dice
